/*
 * 
 * Creation des fichiers personnage ou sprites 'EXTERNES'
 *
 */

#include "include.h"
#include "macro.h"
#include "string92.h"

#define TAMPON 65536
#define DECA   86+2

int
main (int argc, const char *argv[])
{
  FILE *F1;
  ub *buf;
  ul Size;

  /* Check args */
  if (argc < 3)
    {
      printf ("Usage : %s Prog.9XZ SPR_EXT.9XS [-b]\n", argv[0]);
      exit (EXIT_FAILURE);
    }

  /* Alloc memory */
  if ((buf = malloc (sizeof (ub) * TAMPON)) == NULL)
    {
      printf ("memory full !\n");
      exit (EXIT_FAILURE);
    }

  /* Load file */
  if ((F1 = fopen (argv[1], "rb")) == NULL)
    {
      printf ("File %s not found.\n", argv[1]);
      exit (EXIT_FAILURE);
    }
  /* Skip data */
  if ((fseek (F1, DECA, SEEK_SET)) != 0)
    {
      printf ("Error when loading %s.\n", argv[1]);
      exit (EXIT_FAILURE);
    }
  /* Read and close */
  Size = fread (buf, sizeof (ub), TAMPON, F1);
  fclose (F1);

  printf ("Size : %u, File : %s \n", (unsigned int) Size, argv[2]);

  /* Create the file */
  if (argc >= 4 && strcmp (argv[3], "-b") == 0)
    {
      if ((F1 = fopen (argv[2], "wb")) == NULL)
	{
	  printf ("Can't create file %s .\n", argv[2]);
	  exit (EXIT_FAILURE);
	}
      fwrite (buf, sizeof (ub), Size, F1);
      fclose (F1);
      printf ("BIN file created !\n");
    }
  else
    {
      if (Create92S ((char *) buf, Size, (char *) argv[2]) == 0)
	printf ("Done !\n");
      else
	printf ("Error.\n");
    }
  return 0;
}
