#include <stdio.h>
#include <stdlib.h>

#include "macro.h"

static int num_file = 0;

FILE *
xopen (const char *Name, const char *arg)
{
  FILE *F;
  if (!(F = fopen (Name, arg)))
    {
      printf ("ERROR: can't open '%s' with '%s' (%u opened files)\n",
	      Name, arg, num_file);
      exit (-1);
    }
  num_file++;
  return F;
}

void
xclose (FILE * F)
{
  fclose (F);
  num_file--;
}

void *
xmalloc (size_t num)
{
  return xalloc (num);
}

void *
xalloc (size_t num)
{
  static ul total = 0;
  void *a0;
  if (!(a0 = malloc (sizeof (ub) * num)))
    {
      printf ("Error : can't allocate %lu bytes (%lu bytes allocated)\n",
	      (unsigned long) num, (unsigned long) total);
      exit (-1);
    }
  total += (long) num;
  return a0;
}

void
xfree (void *f)
{
  free (f);
}


void
xerror (const char *str)
{
  printf (str);
  exit (1);
}


unsigned long
filesize (const char *filename)
{
  long size;
  FILE *F;

  F = xopen (filename, "rb");
  fseek (F, 0, SEEK_END);
  size = ftell (F);
  fclose (F);
  return size;
}

int
file_exists_p (const char *filename)
{
  FILE *F;

  F = fopen (filename, "rb");
  if (F == NULL)
    return 0;
  fclose (F);
  return 1;
}
