#include "include.h"
#include "macro.h"

#define MAX_ANI_TILE 50
#define MAX_STR 256
#define MAX_NBR 5

#define MAX_COMMANDE 5
#define MAX_FREQ 6

typedef struct
{
  ub freq;
  ub type;
  ub opt1;
  ub opt2;
  ub opt3;
  ub opt4;
} ANI_TILE;

ul type_opt[MAX_COMMANDE] = { 2, 2, 2, 2, 3 };

ANI_TILE tile[MAX_ANI_TILE];
ul nbr_tile = 0;
char name_str[MAX_STR];

const char *const commande2[] =
  { "freq", "type", "opt1", "opt2", "opt3", "opt4", "include", "name", 0 };
const char *const commande1[] = { "new", "end", 0 };

void
save ()
{
  FILE *F;
  ul i, j;

  F = xopen (name_str, "wb");
  for (i = 0; i < MAX_FREQ; i++)
    for (j = 0; j < nbr_tile; j++)
      if ((tile[j]).freq == i)
	fwrite (&((tile[j]).type), sizeof (ub), type_opt[((tile[i]).type)],
		F);
  xclose (F);
}

void
create_tile (const char *name)
{
  ANI_TILE current;
  FILE *F;
  ul j;
  ub nbr_arg, nbr;
  char *a0;
  char str0[MAX_STR];

  memset (&current, 0, sizeof current);

  F = xopen (name, "r");
  while (!(feof (F)))
    {
      fscanf (F, "%s\n", str0);
      a0 = str0;
      nbr_arg = 0;
      for (j = 0; (j < 256) && (*(a0)); j++, a0++)
	if (*(a0) == '=')
	  {
	    a0++;
	    nbr_arg = 1;
	    break;
	  }
      if (nbr_arg)
	{
	  *(str0 + j) = 0;
	  nbr = atoi (a0);
	  for (j = 0; commande2[j] != NULL; j++)
	    if (strcmp (str0, commande2[j]) != 0)
	      break;
	  if (commande2[j] != 0)
	    switch (j)
	      {
	      case 0:
		current.freq = nbr;
		break;
	      case 1:
		current.type = nbr;
		break;
	      case 2:
		current.opt1 = nbr;
		break;
	      case 3:
		current.opt2 = nbr;
		break;
	      case 4:
		current.opt3 = nbr;
		break;
	      case 5:
		current.opt4 = nbr;
		break;
	      case 6:
		create_tile (a0);
		break;
	      case 7:
		strcpy (name_str, a0);
		break;
	      default:
		break;
	      }
	}
      else
	{
	  for (j = 0; commande1[j] != NULL; j++)
	    if (strcmp (str0, commande1[j]) != 0)
	      break;
	  if (commande1[j] != 0)
	    switch (j)
	      {
	      case 0:
		tile[nbr_tile++] = current;
		break;
	      case 1:
		save ();
		exit (0);
	      default:
		break;
	      }
	}
    }
  xclose (F);
}

int
main (int argc, const char *argv[])
{
  printf ("SMA WDK: Make animated tiles\n");
  if (argc < 2)
    xerror ("Error : mktile tilefile.ani");
  strcpy (name_str, "tile.bin");
  create_tile (argv[1]);
  return 0;
}
