#include "objtile.h"
#include "plane.h"

void
print_tile (uw x, uw y, ul no, uw flag, BITMAP * Tile_base[])
{
  if (Tile_base[no] == NULL)
    return;

  switch (flag)
    {
    case 3:
      draw_sprite_vh_flip (buffer, Tile_base[no], x, y);
      break;
    case 2:
      draw_sprite_v_flip (buffer, Tile_base[no], x, y);
      break;
    case 1:
      draw_sprite_h_flip (buffer, Tile_base[no], x, y);
      break;
    case 0:
      //blit(Tile_base[no], buffer, 0, 0, x, y, taille, taille);
      draw_sprite (buffer, Tile_base[no], x, y);
      break;
    default:
      printf ("Erreur : Affichage de sprite avec flag invalide !\n");
    }
}

void
print_selected_tile (uw x, uw y, uw taille)
{
  rect (buffer, x, y, x + taille, y + taille, SELECTED);
}

void
print_selected2_tile (uw x, uw y, uw taille)
{
  rect (buffer, x, y, x + taille, y + taille, SELECTED2);
}



ul
load_tile (char *tile_name, uw type, uw taille, ul num_tiles,
	   BITMAP * tile_base[])
{
  FILE *F1;
  ul no = 0, i = 0, j = 0;
  BITMAP *temp;

  // Remplissage de NULL
  for (i = 0; i < num_tiles; i++)
    tile_base[i] = NULL;

  if (file_select ("Open tile-file (BIN file)...", tile_name, NULL) == 0)
    {
      printf ("Loading tiles canceled by user\n");
      return 0;
    }

  if ((F1 = fopen (tile_name, "rb")) == NULL)
    {
      printf ("Error : can't open %s (r)\n", tile_name);
      return 0;
    }

  while (!(feof (F1)))
    {
      switch (type)
	{
	case 1:
	  {
	    ub s1, s2, mask;
	    if ((temp = create_bitmap (taille, taille)) == NULL)
	      {
		printf ("Memory full : can't create a new bitmap !\n");
		return 0;
	      }
	    for (j = 0; j < taille; j++)
	      {
		if (fread (&s1, sizeof (ub), 1, F1) == 0)
		  goto fin_de_lecture;
		fread (&s2, sizeof (ub), 1, F1);
		for (i = 0; i < taille; i++)
		  {
		    if (s1 & (LSL (1, (taille - 1 - i))))
		      {
			if (s2 & (LSL (1, (taille - 1 - i))))
			  putpixel (temp, i, j, BLACK);
			else
			  putpixel (temp, i, j, GREYD);
		      }
		    else
		      {
			if (s2 & (LSL (1, (taille - 1 - i))))
			  putpixel (temp, i, j, GREYH);
			else
			  putpixel (temp, i, j, WHITE);
		      }
		  }
	      }
	    tile_base[no] = temp;
	  }
	  break;
	case 2:
	  {
	    uw s1, s2, mask;
	    ub v1[2], v2[2];
	    if ((temp = create_bitmap (taille, taille)) == NULL)
	      {
		printf ("Memory full : can't create a new bitmap !\n");
		return 0;
	      }
	    for (j = 0; j < taille; j++)
	      {
		if (fread (v1, sizeof (ub), 2, F1) == 0)
		  goto fin_de_lecture;
		fread (v2, sizeof (ub), 2, F1);
		s1 = LSL (v1[0], 8) + v1[1];
		s2 = LSL (v2[0], 8) + v2[1];
		for (i = 0; i < taille; i++)
		  {
		    if (s1 & (LSL (1, (taille - 1 - i))))
		      {
			if (s2 & (LSL (1, (taille - 1 - i))))
			  putpixel (temp, i, j, BLACK);
			else
			  putpixel (temp, i, j, GREYD);
		      }
		    else
		      {
			if (s2 & (LSL (1, (taille - 1 - i))))
			  putpixel (temp, i, j, GREYH);
			else
			  putpixel (temp, i, j, WHITE);
		      }
		  }
	      }
	    tile_base[no] = temp;
	    break;
	  }
	case 3:
	  {
	    ul s1, mask;
	    ub v1[3];
	    if ((temp = create_bitmap (taille, taille)) == NULL)
	      {
		printf ("Memory full : can't create a new bitmap !\n");
		return 0;
	      }
	    for (j = 0; j < taille; j++)
	      {
		if (fread (v1, sizeof (ub), 4, F1) == 0)
		  goto fin_de_lecture;
		s1 = LSL (v1[0], 24) + LSL (v1[1], 16) + LSL (v1[2], 8)
		  + v1[3];
		for (i = 0; i < taille; i++)
		  {
		    if (s1 & (LSL (1, (taille - 1 - i))))
		      putpixel (temp, i, j, BLACK);
		    else
		      putpixel (temp, i, j, WHITE);
		  }
	      }
	    tile_base[no] = temp;
	    break;
	  }
	default:
	  printf ("Error bad type : %u\n", type);
	  return 0;
	  break;
	}
      no++;
      if (no >= num_tiles)
	goto fin_de_lecture;
    }
fin_de_lecture:		/* Rien que pour les anti-goto ;) */
  fclose (F1);
  printf ("%u tiles opened !\n", no);
  return no;
}
